//------------------------------------------------------------------------------
//
//  Glass Dices
//
//  Author: Bonsai (mail: bonsai@b0n541.net)
//
//  Copyright: GNU General Public License 
//
//------------------------------------------------------------------------------

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

global_settings
        {
        ambient_light White
        max_trace_level 50
        }

background {color rgb <0.9, 0.8, 0.9>}

camera
	{
	location <3, 4, -3>
	look_at <0, 1, 0>
	}

light_source
	{
	<2, 4, -3> color White
	}

light_source
	{
	<-2, 4, -3> color White
	}

light_source
	{
	<-3, 9, 3> color White
	}


// The Dice modelling
#declare Dice =

difference
	{
	intersection
		{
		//main object (dice with round edges)
		sphere
			{
			<0, 0, 0>, 0.705
			}

		box
			{
			<-0.5, -0.5, -0.5>
			<0.5, 0.5, 0.5>
			}
		}

	//now the little holes
	//Side 1
	sphere
		{
		<0, 0.497, 0>, 0.075
		pigment { color White }
		}

	//Side 2
	sphere
		{
		<-0.497, 0.25, 0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.497, -0.25, -0.25>, 0.075
		pigment { color White }
		}

	//Side 3
	sphere
		{
		<0, 0, -0.497>, 0.075
		pigment { color White }
		}

	sphere 
		{
		<0.25, -0.25, -0.497>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, 0.25, -0.497>, 0.075
		pigment { color White }
		}

	//Side 4
	sphere
		{
		<0.25, 0.25, 0.497>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.25, -0.25, 0.497>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, 0.25, 0.497>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, -0.25, 0.497>, 0.075
		pigment { color White }
		} 

	//Side 5
	sphere
		{
		<0.497, 0, 0>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.497, 0.25, -0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.497, 0.25, 0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.497, -0.25, -0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.497, -0.25, 0.25>, 0.075
		pigment { color White }
		}

	//Side 6
	sphere
		{
		<0.25, -0.497, 0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.25, -0.497, 0>, 0.075
		pigment { color White }
		}

	sphere
		{
		<0.25, -0.497, -0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, -0.497, 0.25>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, -0.497, 0>, 0.075
		pigment { color White }
		}

	sphere
		{
		<-0.25, -0.497, -0.25>, 0.075
		pigment { color White }
		}
	}

plane
	{
	<0, 1, 0>, 0
	texture
		{
		pigment { color rgb <0.8, 0.8, 0.8> }
		}
	}

//placing and texturing the dices
object 
	{
	Dice
	texture
		{
		NBglass
		pigment { color rgb <1, 1, 0, 0.5> }
		}
	rotate <0, -102, 180>
	translate <1, 0.5, 1>
	}

object
	{
	Dice
	texture
		{
		NBglass
		pigment { color rgb <1, 0, 0, 0.5> }
		}
	translate <0, 0.5, 0>
	}

object
	{
	Dice
	texture
		{
		NBglass
		pigment { color rgb <0, 1, 0, 0.5> }
		}
	rotate <23, 0, 90>
	translate <-1.5, 0.5, -1>
	}

object
	{
	Dice
	texture
		{
		NBglass
		pigment { color rgb <0, 0, 1, 0.5> }
		}
	rotate <90, 47, 0>
	translate <0.5, 0.5, -2>
	}


object
	{
	Dice
	texture
		{
		NBglass
		pigment {color rgb <1, 0, 0, 0.5> }
		}
	rotate <-90, 30, 0>
	translate <-2, 0.5, 2>
	}

object
	{
	Dice
	texture
		{
		NBglass
		pigment {color rgb <0, 0, 1, 0.5> }
		}
	rotate <0, 0, -90>
	rotate <0, 35, 0>
	translate <0, 0.5, 2>
	}
